#include <malloc.h>
#include <stdlib.h>
#include <memory.h>
#include "stack.h"
#include "board.h"
#include "search.h"
#include "main.h"

int board_iswin(struct ch_board *b_in, int black)
{
    int i, j = 0;
    struct ch_movelist *ml;
    

    if (black) { 
	for (i = B_START; i < B_END; i++)
	    if (IS_WHITE(b_in->square[i])) j++;
    } else {
	for (i = B_START; i < B_END; i++)
            if (IS_BLACK(b_in->square[i])) j++;
    }

    if (j) {
	ml = move_generate(b_in, !black);
	i = ml->num;
	free(ml);
	if (i)
	    return FALSE;
    }
    return TRUE;
}

void board_clone(struct ch_board *b_in, struct ch_board *b_out)
{
    int i;

    for (i = 0; i < 32; i++)
	b_out->square[board_pos[i]] = b_in->square[board_pos[i]];

    b_out->total_time = b_in->total_time;
    b_out->isblack = b_in->isblack;
    b_out->elapsed_time = b_in->elapsed_time;
    b_out->op_moves = b_in->op_moves;
    b_out->my_moves = b_in->my_moves;
}
void board_clear(struct ch_board *b_in)
{
    int i;

    for (i = 0; i < 100; i++)
	b_in->square[i] = B_EMPTY;

    for (i = 0; i < 10; i++) {
	b_in->square[i] = B_INVAL;
	b_in->square[i + 90] = B_INVAL;
    }

    for (i = 0; i < 100; i+=10) {
	b_in->square[i] = B_INVAL;
	b_in->square[i + 9] = B_INVAL;
    }
}


void board_free(struct ch_board *ob)
{
    if (ob != NULL){
	free(ob);
	/*free old boards memory usage "i hope" */
    }
}
struct ch_board *board_init()
{
    int i, addy = 3;
    struct ch_board *newboard;
    newboard=malloc(sizeof(struct ch_board));

    newboard->elapsed_time = 0;
    newboard->my_moves = newboard->op_moves = 0;

    for (i = 10; i < 40; i++)
	newboard->square[i] = B_BLACK;
    for (i = 60; i < 90; i++)
        newboard->square[i] = B_WHITE;
    
    /* set the top & botom lines */
    for (i = 0; i < 10; i++) { 
	newboard -> square[i] = B_INVAL;
	newboard -> square[i+90] = B_INVAL;
    }

    /* set the right & left colums */
    for (i=10; i < 100; i += 10) {
	newboard -> square[i] = B_INVAL;
	newboard -> square[i+9] = B_INVAL;
    }
    
    for (i=11;i< B_END ;i+=2){
	if (newboard->square[i] == B_INVAL) {
	    i += addy;
	    addy = addy == 3 ? 1 : 3;
	}
	newboard -> square[i] = B_EMPTY;
    }

    /* set the rest of the invalid squares and asign black & white markers 
       on the board */

    return newboard;
}

