
#ifndef __SEARCH_H__
#define __SEARCH_H__

#include "stack.h"
#include "board.h"
#include "main.h"

#define STARTDEPTH 3
#define MAXDEPTH 1000 /* We should never get this far */
#define MAXJUMPS 64 /* hmm? */
#define MAXMOVES 64


struct ch_move {
    int util;
    float time; /* How long did it take for the search to do this move */
    int num;
    int hops;
    int hash;
    int moveto[MAXJUMPS]; /* The hops for the checker */
};

struct ch_movelist {
    int num;
    struct ch_move *hist;
    struct ch_move moves[MAXMOVES];
};

struct ch_move *search_move(struct ch_board *);
struct ch_movelist *move_generate(struct ch_board *, int);
void move_freeall(struct ch_movelist *);
void move_make(struct ch_board *, struct ch_board *, struct ch_move *);
int move_cantake(struct ch_board *, int);
void move_promote(struct ch_board *b_in, int i);
void move_history(struct ch_move *);
void move_clearkill();
void move_killer(struct ch_move *, int);
struct ch_move *move_findkill(struct ch_movelist *, int);
void search_init();
void move_init();
void move_tofront(struct ch_movelist *ml);
#endif


