/*
 * A simple, semigeneric stack.
 */

#include <stdlib.h>
#include "stack.h"

struct stacknode {
    struct stacknode *next;
    void *data;
};

struct stack *stack_init()
{
    struct stack *st = malloc(sizeof(struct stack));

    st->top = 0;
    st->count = 0;
    return st;
}

void push(struct stack *st, void *in)
{
    struct stacknode *nn;

    nn = malloc (sizeof(struct stacknode));
    nn->next = st->top;
    st->top = nn;
    nn->data = in;
    st->count++;
}

void *pop(struct stack *st)
{
    struct stacknode *sn = st->top;
    void *data;

    if (!st->top)
	return 0;

    st->top = sn->next;
    st->count--;
    data = sn->data;
    free(sn);

    return data;
}
